#----------
# Scenario:
#----------
#    1. A WCF Service (IService1) has a method called GetToken() which returns a string token.
#
#			public string GetToken()  {  returns "A string token"; }
#				  
#     2. Another WCF Service (IService2) has methods which expects a token as one of the parameters to its method.
#
#           public bool DoSomething(string token, int someValue)  
#           { 
#                // DO something
#                 return true;
#           }
#
#     Test Case : Invoke service1.GetToken() and then invoke service2.DoSomething() passing to it the token
#-------------------------------------------------------------------------------------------------------------------------


import clr
clr.AddReference("System.XML.dll")

import System.Xml
from System.Xml import XmlDocument

class MySvc:

  def __init__(self, url, contractName):
     self.url = url
     self.contractName = contractName
  def InvokeMethod(self, methodName, xmlInput):
     xmlResp = task.InvokeMethod(self.url, self.contractName , methodName, xmlInput)
     return xmlResp
	 
class MyTestWorkFlow:
  """this is the documentation for the test workflow"""

  xmlInputGetToken = "\
  <GetToken>\
    <MethodParameters>\
      <username>myusername</username>\
      <password>mypassword</password>\
    </MethodParameters>\
  </GetToken>"
  
  xmlInputDoSOmething = "\
  <DoSomething>\
    <MethodParameters>\
      <token>sometoken</token>\
      <someValue>42</someValue>\
    </MethodParameters>\
  </DoSomething>"
  
  def Run(self):
    svc1 = MySvc("http://localhost:57195/Service1.svc", "IService1")
    svc2 = MySvc("http://localhost:57195/Service1.svc", "IService2")
	
    print "Invoking GetToken...\n"
    svc1Resp = svc1.InvokeMethod("GetToken", self.xmlInputGetToken)
    print "Response is: " + svc1Resp
	
    svc1Doc = XmlDocument()
    svc1Doc.LoadXml(svc1Resp)
    token = svc1Doc.SelectSingleNode("/GetToken/MethodParameters/String").InnerText
    print "token retrieved from IService1 is " + token

    docDoSomething = XmlDocument()
    docDoSomething .LoadXml(self.xmlInputDoSOmething)
	
    #Use the token retrieved from svc1
    docDoSomething .SelectSingleNode("/DoSomething/MethodParameters/token").InnerText = token
	
    #invoke IService2 with token retrieved from IService1
    print "Invoking DoSomething..."
    print "Input is " +  docDoSomething .OuterXml
    doSomethingXmlResp = svc2.InvokeMethod("DoSomething", docDoSomething.OuterXml)
    doSomethingXmlDoc = XmlDocument()
    doSomethingXmlDoc.LoadXml(doSomethingXmlResp)
    
	
    if doSomethingXmlDoc.SelectSingleNode("/DoSomething/MethodParameters/Boolean").InnerText == "True":
     print "token " + token + " is valid!"
    else:
     print "invalid token"

test = MyTestWorkFlow()
for i in range(1,10):
  test.Run() 